///////////////////////////////////////////////////////////////-*-C-*-
//
// Copyright (c) 2007 Xilinx, Inc.  All rights reserved.
//
// Xilinx, Inc.  XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION
// "AS IS" AS  A COURTESY TO YOU.  BY PROVIDING  THIS DESIGN, CODE, OR
// INFORMATION  AS  ONE   POSSIBLE  IMPLEMENTATION  OF  THIS  FEATURE,
// APPLICATION OR  STANDARD, XILINX  IS MAKING NO  REPRESENTATION THAT
// THIS IMPLEMENTATION  IS FREE FROM  ANY CLAIMS OF  INFRINGEMENT, AND
// YOU ARE  RESPONSIBLE FOR OBTAINING  ANY RIGHTS YOU MAY  REQUIRE FOR
// YOUR  IMPLEMENTATION.   XILINX  EXPRESSLY  DISCLAIMS  ANY  WARRANTY
// WHATSOEVER  WITH RESPECT  TO  THE ADEQUACY  OF THE  IMPLEMENTATION,
// INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR REPRESENTATIONS THAT
// THIS IMPLEMENTATION  IS FREE  FROM CLAIMS OF  INFRINGEMENT, IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// 
//////////////////////////////////////////////////////////////////////

#ifndef __XL_WARPLAB_MIMO_4X4_PLBW_H__
#define __XL_WARPLAB_MIMO_4X4_PLBW_H__

#include "xbasic_types.h"
#include "xstatus.h"
#include "xcope.h"

typedef struct {
    uint32_t version;
    // Pointers to low-level functions
    xc_status_t (*xc_create)(xc_iface_t **, void *);
    xc_status_t (*xc_release)(xc_iface_t **);
    xc_status_t (*xc_open)(xc_iface_t *);
    xc_status_t (*xc_close)(xc_iface_t *);
    xc_status_t (*xc_read)(xc_iface_t *, xc_r_addr_t, uint32_t *);
    xc_status_t (*xc_write)(xc_iface_t *, xc_w_addr_t, const uint32_t);
    xc_status_t (*xc_get_shmem)(xc_iface_t *, const char *, void **shmem);
    // Optional parameters
    // (empty)
    // Memory map information
    uint32_t AGCDoneAddr;
    uint32_t AGCDoneAddr_n_bits;
    uint32_t AGCDoneAddr_bin_pt;
    // uint32_t AGCDoneAddr_attr;
    uint32_t CaptureDone;
    uint32_t CaptureDone_n_bits;
    uint32_t CaptureDone_bin_pt;
    // uint32_t CaptureDone_attr;
    uint32_t Radio1AGCDoneRSSI;
    uint32_t Radio1AGCDoneRSSI_n_bits;
    uint32_t Radio1AGCDoneRSSI_bin_pt;
    // uint32_t Radio1AGCDoneRSSI_attr;
    uint32_t Radio2AGCDoneRSSI;
    uint32_t Radio2AGCDoneRSSI_n_bits;
    uint32_t Radio2AGCDoneRSSI_bin_pt;
    // uint32_t Radio2AGCDoneRSSI_attr;
    uint32_t Radio3AGCDoneRSSI;
    uint32_t Radio3AGCDoneRSSI_n_bits;
    uint32_t Radio3AGCDoneRSSI_bin_pt;
    // uint32_t Radio3AGCDoneRSSI_attr;
    uint32_t Radio4AGCDoneRSSI;
    uint32_t Radio4AGCDoneRSSI_n_bits;
    uint32_t Radio4AGCDoneRSSI_bin_pt;
    // uint32_t Radio4AGCDoneRSSI_attr;
    uint32_t DCO_EN_SEL;
    uint32_t DCO_EN_SEL_n_bits;
    uint32_t DCO_EN_SEL_bin_pt;
    // uint32_t DCO_EN_SEL_attr;
    uint32_t DebugRx1Buffers;
    uint32_t DebugRx1Buffers_n_bits;
    uint32_t DebugRx1Buffers_bin_pt;
    // uint32_t DebugRx1Buffers_attr;
    uint32_t DebugRx2Buffers;
    uint32_t DebugRx2Buffers_n_bits;
    uint32_t DebugRx2Buffers_bin_pt;
    // uint32_t DebugRx2Buffers_attr;
    uint32_t DebugRx3Buffers;
    uint32_t DebugRx3Buffers_n_bits;
    uint32_t DebugRx3Buffers_bin_pt;
    // uint32_t DebugRx3Buffers_attr;
    uint32_t DebugRx4Buffers;
    uint32_t DebugRx4Buffers_n_bits;
    uint32_t DebugRx4Buffers_bin_pt;
    // uint32_t DebugRx4Buffers_attr;
    uint32_t MGC_AGC_SEL;
    uint32_t MGC_AGC_SEL_n_bits;
    uint32_t MGC_AGC_SEL_bin_pt;
    // uint32_t MGC_AGC_SEL_attr;
    uint32_t RADIO1RXBUFF_RXEN;
    uint32_t RADIO1RXBUFF_RXEN_n_bits;
    uint32_t RADIO1RXBUFF_RXEN_bin_pt;
    // uint32_t RADIO1RXBUFF_RXEN_attr;
    uint32_t RADIO1TXBUFF_TXEN;
    uint32_t RADIO1TXBUFF_TXEN_n_bits;
    uint32_t RADIO1TXBUFF_TXEN_bin_pt;
    // uint32_t RADIO1TXBUFF_TXEN_attr;
    uint32_t RADIO2RXBUFF_RXEN;
    uint32_t RADIO2RXBUFF_RXEN_n_bits;
    uint32_t RADIO2RXBUFF_RXEN_bin_pt;
    // uint32_t RADIO2RXBUFF_RXEN_attr;
    uint32_t RADIO2TXBUFF_TXEN;
    uint32_t RADIO2TXBUFF_TXEN_n_bits;
    uint32_t RADIO2TXBUFF_TXEN_bin_pt;
    // uint32_t RADIO2TXBUFF_TXEN_attr;
    uint32_t RADIO3RXBUFF_RXEN;
    uint32_t RADIO3RXBUFF_RXEN_n_bits;
    uint32_t RADIO3RXBUFF_RXEN_bin_pt;
    // uint32_t RADIO3RXBUFF_RXEN_attr;
    uint32_t RADIO3TXBUFF_TXEN;
    uint32_t RADIO3TXBUFF_TXEN_n_bits;
    uint32_t RADIO3TXBUFF_TXEN_bin_pt;
    // uint32_t RADIO3TXBUFF_TXEN_attr;
    uint32_t RADIO4RXBUFF_RXEN;
    uint32_t RADIO4RXBUFF_RXEN_n_bits;
    uint32_t RADIO4RXBUFF_RXEN_bin_pt;
    // uint32_t RADIO4RXBUFF_RXEN_attr;
    uint32_t RADIO4TXBUFF_TXEN;
    uint32_t RADIO4TXBUFF_TXEN_n_bits;
    uint32_t RADIO4TXBUFF_TXEN_bin_pt;
    // uint32_t RADIO4TXBUFF_TXEN_attr;
    uint32_t StartCapture;
    uint32_t StartCapture_n_bits;
    uint32_t StartCapture_bin_pt;
    // uint32_t StartCapture_attr;
    uint32_t StartTx;
    uint32_t StartTx_n_bits;
    uint32_t StartTx_bin_pt;
    // uint32_t StartTx_attr;
    uint32_t StopTx;
    uint32_t StopTx_n_bits;
    uint32_t StopTx_bin_pt;
    // uint32_t StopTx_attr;
    uint32_t TransMode;
    uint32_t TransMode_n_bits;
    uint32_t TransMode_bin_pt;
    // uint32_t TransMode_attr;
    uint32_t TxDelay;
    uint32_t TxDelay_n_bits;
    uint32_t TxDelay_bin_pt;
    // uint32_t TxDelay_attr;
    uint32_t TxLength;
    uint32_t TxLength_n_bits;
    uint32_t TxLength_bin_pt;
    // uint32_t TxLength_attr;
    uint32_t StartTxRx;
    uint32_t StartTxRx_n_bits;
    uint32_t StartTxRx_bin_pt;
    // uint32_t StartTxRx_attr;
    uint32_t RxBuff_Radio1;
    // uint32_t RxBuff_Radio1_grant;
    // uint32_t RxBuff_Radio1_req;
    uint32_t RxBuff_Radio1_n_bits;
    uint32_t RxBuff_Radio1_bin_pt;
    uint32_t RxBuff_Radio1_depth;
    // uint32_t RxBuff_Radio1_attr;
    uint32_t RxBuff_Radio2;
    // uint32_t RxBuff_Radio2_grant;
    // uint32_t RxBuff_Radio2_req;
    uint32_t RxBuff_Radio2_n_bits;
    uint32_t RxBuff_Radio2_bin_pt;
    uint32_t RxBuff_Radio2_depth;
    // uint32_t RxBuff_Radio2_attr;
    uint32_t RxBuff_Radio3;
    // uint32_t RxBuff_Radio3_grant;
    // uint32_t RxBuff_Radio3_req;
    uint32_t RxBuff_Radio3_n_bits;
    uint32_t RxBuff_Radio3_bin_pt;
    uint32_t RxBuff_Radio3_depth;
    // uint32_t RxBuff_Radio3_attr;
    uint32_t RxBuff_Radio4;
    // uint32_t RxBuff_Radio4_grant;
    // uint32_t RxBuff_Radio4_req;
    uint32_t RxBuff_Radio4_n_bits;
    uint32_t RxBuff_Radio4_bin_pt;
    uint32_t RxBuff_Radio4_depth;
    // uint32_t RxBuff_Radio4_attr;
    uint32_t TxBuff_Radio1;
    // uint32_t TxBuff_Radio1_grant;
    // uint32_t TxBuff_Radio1_req;
    uint32_t TxBuff_Radio1_n_bits;
    uint32_t TxBuff_Radio1_bin_pt;
    uint32_t TxBuff_Radio1_depth;
    // uint32_t TxBuff_Radio1_attr;
    uint32_t TxBuff_Radio2;
    // uint32_t TxBuff_Radio2_grant;
    // uint32_t TxBuff_Radio2_req;
    uint32_t TxBuff_Radio2_n_bits;
    uint32_t TxBuff_Radio2_bin_pt;
    uint32_t TxBuff_Radio2_depth;
    // uint32_t TxBuff_Radio2_attr;
    uint32_t TxBuff_Radio3;
    // uint32_t TxBuff_Radio3_grant;
    // uint32_t TxBuff_Radio3_req;
    uint32_t TxBuff_Radio3_n_bits;
    uint32_t TxBuff_Radio3_bin_pt;
    uint32_t TxBuff_Radio3_depth;
    // uint32_t TxBuff_Radio3_attr;
    uint32_t TxBuff_Radio4;
    // uint32_t TxBuff_Radio4_grant;
    // uint32_t TxBuff_Radio4_req;
    uint32_t TxBuff_Radio4_n_bits;
    uint32_t TxBuff_Radio4_bin_pt;
    uint32_t TxBuff_Radio4_depth;
    // uint32_t TxBuff_Radio4_attr;
    uint32_t RSSIBuff_Radio1;
    // uint32_t RSSIBuff_Radio1_grant;
    // uint32_t RSSIBuff_Radio1_req;
    uint32_t RSSIBuff_Radio1_n_bits;
    uint32_t RSSIBuff_Radio1_bin_pt;
    uint32_t RSSIBuff_Radio1_depth;
    // uint32_t RSSIBuff_Radio1_attr;
    uint32_t RSSIBuff_Radio2;
    // uint32_t RSSIBuff_Radio2_grant;
    // uint32_t RSSIBuff_Radio2_req;
    uint32_t RSSIBuff_Radio2_n_bits;
    uint32_t RSSIBuff_Radio2_bin_pt;
    uint32_t RSSIBuff_Radio2_depth;
    // uint32_t RSSIBuff_Radio2_attr;
    uint32_t RSSIBuff_Radio3;
    // uint32_t RSSIBuff_Radio3_grant;
    // uint32_t RSSIBuff_Radio3_req;
    uint32_t RSSIBuff_Radio3_n_bits;
    uint32_t RSSIBuff_Radio3_bin_pt;
    uint32_t RSSIBuff_Radio3_depth;
    // uint32_t RSSIBuff_Radio3_attr;
    uint32_t RSSIBuff_Radio4;
    // uint32_t RSSIBuff_Radio4_grant;
    // uint32_t RSSIBuff_Radio4_req;
    uint32_t RSSIBuff_Radio4_n_bits;
    uint32_t RSSIBuff_Radio4_bin_pt;
    uint32_t RSSIBuff_Radio4_depth;
    // uint32_t RSSIBuff_Radio4_attr;
    // XPS parameters
    Xuint16  DeviceId;
    uint32_t  BaseAddr;
} WARPLAB_MIMO_4X4_PLBW_Config;

extern WARPLAB_MIMO_4X4_PLBW_Config WARPLAB_MIMO_4X4_PLBW_ConfigTable[];

// forward declaration of low-level functions
xc_status_t xc_warplab_mimo_4x4_plbw_create(xc_iface_t **iface, void *config_table);
xc_status_t xc_warplab_mimo_4x4_plbw_release(xc_iface_t **iface) ;
xc_status_t xc_warplab_mimo_4x4_plbw_open(xc_iface_t *iface);
xc_status_t xc_warplab_mimo_4x4_plbw_close(xc_iface_t *iface);
xc_status_t xc_warplab_mimo_4x4_plbw_read(xc_iface_t *iface, xc_r_addr_t addr, uint32_t *value);
xc_status_t xc_warplab_mimo_4x4_plbw_write(xc_iface_t *iface, xc_w_addr_t addr, const uint32_t value);
xc_status_t xc_warplab_mimo_4x4_plbw_getshmem(xc_iface_t *iface, const char *name, void **shmem);

#endif

